Attribute VB_Name = "modPrinter"
' vbzTipp   : Verschiedenes / vbzPrinter
' Nummer    : 0003
' Stand     : 19.01.2008
' Quelle    : http://www.vb-zentrum.de
' Autor     : ralf schlegel

Option Explicit

' Declaration Druckerfunktionen:
Private Declare Function intSetDefaultPrinter Lib "winspool.drv" Alias "SetDefaultPrinterA" _
        (ByVal sPrinterName As String) As Long
Private Declare Function intGetDefaultPrinter Lib "winspool.drv" Alias "GetDefaultPrinterA" _
        (ByVal sPrinterName As String, lPrinterNameBufferSize As Long) As Long
' Anmerkung: obwohl der Druckername in 'GetDefaultPrinter' ber die Variable 'sPrinterName'
'            zurckgeliefert wird muss die Deklarartion 'ByVal' lauten. 'ByRef' fhrt zum Absturz!

' Ermittelt den Standarddrucker auf System-Ebene
Public Function getDefaultPrinter() As String
  Dim buffer As String * 128
  Dim lbuf As Long
  
  lbuf = Len(buffer)
  If intGetDefaultPrinter(buffer, lbuf) Then
    getDefaultPrinter = Left$(buffer, lbuf - 1)
  Else
    getDefaultPrinter = vbNullString
  End If
End Function

' Setzt den Standarddrucker auf System-Ebene
' gibt TRUE zurck, wenn Alles funktioniert hat
Public Function setDefaultPrinter(ByVal PrinterName As String) As Boolean
  Dim prn As Printer
  
  For Each prn In Printers
    If prn.DeviceName = PrinterName Then
      setDefaultPrinter = CBool(intSetDefaultPrinter(PrinterName))
      Exit For
    End If
  Next
End Function



